diff --git a/game/client/src/main/resources/shaders/particle.vsh b/game/client/src/main/resources/shaders/particle.vsh
index f9bbfcdcd..a23f94354 100644
--- a/game/client/src/main/resources/shaders/particle.vsh
+++ b/game/client/src/main/resources/shaders/particle.vsh
@@ -4,7 +4,7 @@ layout (location = 1) in float aScale;
 layout (location = 2) in vec4 aColor;
 layout (location = 3) in vec2 aUv;
 layout (location = 4) in vec2 aUvSizes;
-layout (location = 5) in vec2 aLightmap;
+layout (location = 5) in float aLightmap;
 
 out VS_OUT {
     float scale;
@@ -14,6 +14,11 @@ out VS_OUT {
     vec2 lightmap;
 } vs_out;
 
+vec2 unpackLightCoord() {
+    int asInt = int(aLightmap);
+    return vec2(((asInt & 0xF) + 0.5)/16.0, (((asInt & 0xF0) >> 4) + 0.5)/16.0);
+}
+
 void main() {
     gl_Position = vec4(aPos, 1);
 
@@ -21,5 +26,5 @@ void main() {
     vs_out.color = aColor;
     vs_out.uv = aUv;
     vs_out.uvSizes = aUvSizes;
-    vs_out.lightmap = aLightmap;
+    vs_out.lightmap = unpackLightCoord();
 }
diff --git a/game/client/src/main/resources/shaders/terrain.fsh b/game/client/src/main/resources/shaders/terrain.fsh
index fda0727cb..e4d7c4da6 100644
--- a/game/client/src/main/resources/shaders/terrain.fsh
+++ b/game/client/src/main/resources/shaders/terrain.fsh
@@ -3,10 +3,11 @@
 out vec4 FragColor;
 
 in vec4 Color;
+in float Shade;
 in vec2 TexCoord;
 in vec2 LightMapCoord;
 in vec3 Light;
-in vec3 Norm;
+in vec4 Norm;
 
 uniform float uAlphaTest;
 uniform vec4 uColor;
@@ -30,7 +31,7 @@ layout (std140) uniform Matrices {
 uniform sampler2D colortex;
 uniform sampler2D lighttex;
 uniform sampler2D emmisivetex;
-//uniform sampler2D colormasktex;
+uniform sampler2D colormasktex;
 
 float distance() {
     vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0 - 1.0, gl_FragCoord.z * 2.0 - 1.0, 1.0);
@@ -73,14 +74,11 @@ void main() {
     vec4 emmisiveColor = texture(emmisivetex, TexCoord);
     vec4 lightColor = texture(lighttex, vec2(max(LightMapCoord.x, emmisiveColor.r), max(LightMapCoord.y, emmisiveColor.g)));
     vec4 texColor = texture(colortex, TexCoord);
-    //    vec4 maskColor = texture(colormasktex, TexCoord);
+    vec4 maskColor = texture(colormasktex, TexCoord);
 
-    vec4 oColor = texColor * lightColor;
+    vec4 c = vec4(mix(vec3(1, 1, 1), Color.rgb, maskColor.r), 1) * uColor;
 
-//    vec4 c = mix(vec4(1, 1, 1, 1), Color, maskColor.r);
-    vec4 c = Color;
-
-    vec4 postColor = oColor * c * uColor;
+    vec4 postColor = texColor * c * Shade * lightColor;
     vec4 litColor = vec4(postColor.rgb * clamp(Light, 0, 1), postColor.a);
 //    vec4 litColor = vec4(abs(Norm), 1f);
 
diff --git a/game/client/src/main/resources/shaders/terrain.gsh b/game/client/src/main/resources/shaders/terrain.gsh
new file mode 100644
index 000000000..41418cffa
--- /dev/null
+++ b/game/client/src/main/resources/shaders/terrain.gsh
@@ -0,0 +1,105 @@
+#version 330 core
+layout (points) in;
+layout (triangle_strip, max_vertices = 4) out;
+
+in VS_OUT {
+    vec3 sourcePos;
+    vec3 sourceColor;
+    vec3 sourceNormal;
+
+    vec2 V1UV;
+    vec2 V1LightShade;
+
+    vec3 V2PosOffset;
+    vec2 V2UV;
+    vec2 V2LightShade;
+
+    vec3 V3PosOffset;
+    vec2 V3UV;
+    vec2 V3LightShade;
+
+    vec3 V4PosOffset;
+    vec2 V4UV;
+    vec2 V4LightShade;
+} gs_in[];
+
+out vec4 Color;
+out float Shade;
+out vec2 TexCoord;
+out vec2 LightMapCoord;
+out vec3 Light;
+out vec4 Norm;
+
+uniform mat4 model;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+uniform mat4 normalTransform;
+uniform vec4 lightModelAmbient;
+uniform vec4 lightSourcePosition1;
+uniform vec4 lightSourcePosition2;
+uniform vec4 lightSourceDiffuse1;
+uniform vec4 lightSourceDiffuse2;
+
+vec2 unpackLightCoord(vec2 lightShade) {
+    int asInt = int(lightShade.y);
+    return vec2(((asInt & 0xF) + 0.5)/16.0, (((asInt & 0xF0) >> 4) + 0.5)/16.0);
+}
+
+float unpackShade(vec2 lightShade) {
+    return lightShade.x/256;
+}
+
+vec3 expand(vec3 source, vec3 center, float expandAmount) {
+    vec3 diff = source - center;
+    return center + diff * expandAmount;
+}
+
+vec2 expand(vec2 source, vec2 center, float expandAmount) {
+    vec2 diff = source - center;
+    return center + diff * expandAmount;
+}
+
+void main() {
+    Norm = normalize(normalTransform * model * vec4(gs_in[0].sourceNormal, 0));
+    float dir1 = max(0.0, dot(Norm, lightSourcePosition1));
+    float dir2 = max(0.0, dot(Norm, lightSourcePosition2));
+    Light = (lightModelAmbient + lightSourceDiffuse1 * (dir1 + dir2)).xyz;
+
+    vec3 posCenter = gs_in[0].sourcePos + (gs_in[0].V2PosOffset + gs_in[0].V3PosOffset + gs_in[0].V4PosOffset)/3;
+    vec2 uvCenter = (gs_in[0].V1UV + gs_in[0].V2UV + gs_in[0].V3UV + gs_in[0].V4UV)/4;
+
+    Color = vec4(gs_in[0].sourceColor, 1);
+    Shade = unpackShade(gs_in[0].V1LightShade);
+    TexCoord = expand(gs_in[0].V1UV, uvCenter, 0.995f);
+    LightMapCoord = unpackLightCoord(gs_in[0].V1LightShade);
+    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos, posCenter, 1.0005f), 1);
+    EmitVertex();
+
+    Color = vec4(gs_in[0].sourceColor, 1);
+    Shade = unpackShade(gs_in[0].V2LightShade);
+    TexCoord = expand(gs_in[0].V2UV, uvCenter, 0.995f);
+    LightMapCoord = unpackLightCoord(gs_in[0].V2LightShade);
+    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos + gs_in[0].V2PosOffset, posCenter, 1.0005f), 1);
+    EmitVertex();
+
+    Color = vec4(gs_in[0].sourceColor, 1);
+    Shade = unpackShade(gs_in[0].V4LightShade);
+    TexCoord = expand(gs_in[0].V4UV, uvCenter, 0.995f);
+    LightMapCoord = unpackLightCoord(gs_in[0].V4LightShade);
+    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos + gs_in[0].V4PosOffset, posCenter, 1.0005f), 1);
+    EmitVertex();
+
+    Color = vec4(gs_in[0].sourceColor, 1);
+    Shade = unpackShade(gs_in[0].V3LightShade);
+    TexCoord = expand(gs_in[0].V3UV, uvCenter, 0.995f);
+    LightMapCoord = unpackLightCoord(gs_in[0].V3LightShade);
+    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos + gs_in[0].V3PosOffset, posCenter, 1.0005f), 1);
+    EmitVertex();
+
+    EndPrimitive();
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/terrain.vsh b/game/client/src/main/resources/shaders/terrain.vsh
index bad079d51..53d29cb43 100644
--- a/game/client/src/main/resources/shaders/terrain.vsh
+++ b/game/client/src/main/resources/shaders/terrain.vsh
@@ -1,43 +1,64 @@
 #version 410 core
-layout (location = 0) in vec3 aPos;
-layout (location = 1) in vec4 aColor;
-layout (location = 2) in vec2 aUV;
-layout (location = 3) in vec2 aLightmap;
-layout (location = 4) in vec3 aNormal;
-
-out vec4 Color;
-out vec2 TexCoord;
-out vec2 LightMapCoord;
-out vec3 Light;
-out vec3 Norm;
-
-uniform mat4 normalTransform;
-uniform vec4 lightModelAmbient;
-uniform vec4 lightSourcePosition1;
-uniform vec4 lightSourcePosition2;
-uniform vec4 lightSourceDiffuse1;
-uniform vec4 lightSourceDiffuse2;
-
-uniform mat4 model;
-
-layout (std140) uniform Matrices {
-    mat4 projection;
-    mat4 projectionInv;
-    mat4 view;
-    mat4 viewInv;
-} matrices;
+// Only guranteed 16 4 comp locations, so some attributes are packed together to save count, see (https://docs.gl/gl4/glGet @ GL_MAX_VERTEX_ATTRIBS)
+// Can combine uv and light shade in future if number needs further reduction
+layout (location = 0) in vec3 aSourcePos;
+layout (location = 1) in vec3 aSourceColor;
+layout (location = 2) in vec3 aSourceNormal;
+
+// Vertex one uses the position of the source pos
+layout (location = 3) in vec2 aV1UV;
+layout (location = 4) in vec2 aV1LightShade;
+
+layout (location = 5) in vec3 aV2PosOffset;
+layout (location = 6) in vec2 aV2UV;
+layout (location = 7) in vec2 aV2LightShade;
+
+layout (location = 8) in vec3 aV3PosOffset;
+layout (location = 9) in vec2 aV3UV;
+layout (location = 10) in vec2 aV3LightShade;
+
+layout (location = 11) in vec3 aV4PosOffset;
+layout (location = 12) in vec2 aV4UV;
+layout (location = 13) in vec2 aV4LightShade;
+
+out VS_OUT {
+    vec3 sourcePos;
+    vec3 sourceColor;
+    vec3 sourceNormal;
+
+    vec2 V1UV;
+    vec2 V1LightShade;
+
+    vec3 V2PosOffset;
+    vec2 V2UV;
+    vec2 V2LightShade;
+
+    vec3 V3PosOffset;
+    vec2 V3UV;
+    vec2 V3LightShade;
+
+    vec3 V4PosOffset;
+    vec2 V4UV;
+    vec2 V4LightShade;
+} vs_out;
 
 void main() {
-    vec4 p = vec4(aPos, 1);
-    gl_Position = matrices.projection * matrices.view * model * p;
-
-    TexCoord = aUV;
-    Color = aColor;
-    LightMapCoord = aLightmap;
-
-    Norm = normalize(aNormal);
-    vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
-    float dir1 = max(0.0, dot(norm, lightSourcePosition1));
-    float dir2 = max(0.0, dot(norm, lightSourcePosition2));
-    Light = (lightModelAmbient + lightSourceDiffuse1 * (dir1 + dir2)).xyz;
+    vs_out.sourcePos = aSourcePos;
+    vs_out.sourceColor = aSourceColor;
+    vs_out.sourceNormal = aSourceNormal;
+
+    vs_out.V1UV = aV1UV;
+    vs_out.V1LightShade = aV1LightShade;
+
+    vs_out.V2PosOffset = aV2PosOffset;
+    vs_out.V2UV = aV2UV;
+    vs_out.V2LightShade = aV2LightShade;
+
+    vs_out.V3PosOffset = aV3PosOffset;
+    vs_out.V3UV = aV3UV;
+    vs_out.V3LightShade = aV3LightShade;
+
+    vs_out.V4PosOffset = aV4PosOffset;
+    vs_out.V4UV = aV4UV;
+    vs_out.V4LightShade = aV4LightShade;
 }
diff --git a/game/client/src/main/resources/shaders/world.vsh b/game/client/src/main/resources/shaders/world.vsh
index ed183056e..aebf0b0d8 100644
--- a/game/client/src/main/resources/shaders/world.vsh
+++ b/game/client/src/main/resources/shaders/world.vsh
@@ -2,7 +2,7 @@
 layout (location = 0) in vec3 aPos;
 layout (location = 1) in vec4 aColor;
 layout (location = 2) in vec2 aUV;
-layout (location = 3) in vec2 aLightmap;
+layout (location = 3) in float aLightmap;
 layout (location = 4) in vec3 aNormal;
 
 out vec4 Color;
@@ -27,13 +27,18 @@ layout (std140) uniform Matrices {
     mat4 viewInv;
 } matrices;
 
+vec2 unpackLightCoord() {
+    int asInt = int(aLightmap);
+    return vec2(((asInt & 0xF) + 0.5)/16.0, (((asInt & 0xF0) >> 4) + 0.5)/16.0);
+}
+
 void main() {
     vec4 p = vec4(aPos, 1);
     gl_Position = matrices.projection * matrices.view * model * p;
 
     TexCoord = (texture * vec4(aUV, 0.0, 1.0)).xy;
     Color = aColor;
-    LightMapCoord = aLightmap;
+    LightMapCoord = unpackLightCoord();
 
     vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
     float dir1 = max(0.0, dot(norm, lightSourcePosition1));
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index 5089647be..645222364 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -342,8 +342,8 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public int getLightmapCoord(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
-        return this.logic.getLightmapCoord(source, tilePos);
+    public byte getLightIndex(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return this.logic.getLightIndex(source, tilePos);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
index a3bd4dac6..d4d212a36 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
@@ -91,11 +91,11 @@ interface BlockInterface {
         return this.getBrightness(source, new TilePos(x, y, z));
     }
 
-    int getLightmapCoord(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
+    byte getLightIndex(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default int getLightmapCoord(final @NotNull WorldSource source, final int x, final int y, final int z) {
-        return this.getLightmapCoord(source, new TilePos(x, y, z));
+        return this.getLightIndex(source, new TilePos(x, y, z));
     }
 
     /**
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index c52700d53..3d75f6085 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -34,7 +34,6 @@ import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
 import java.util.List;
-import java.util.Objects;
 import java.util.Random;
 
 public class BlockLogic implements BlockInterface, IItemConvertible {
@@ -132,8 +131,8 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     }
 
     @Override
-    public int getLightmapCoord(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
-        return source.getLightmapCoord(tilePos, this.block.emission);
+    public byte getLightIndex(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return source.getLightIndex(tilePos, this.block.emission);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
index 4fc091ab0..16cc73ec2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
@@ -3,7 +3,9 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -21,7 +23,7 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLogicRepeater extends BlockLogic {
+public class BlockLogicRepeater extends BlockLogic implements ISupportable {
     public static final double[] torchPosOffset = {
         -0.0625D, 0.0625D, 0.1875D, 0.3125D
     };
@@ -55,7 +57,7 @@ public class BlockLogicRepeater extends BlockLogic {
 
     @Override
     public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
-        return world.canPlaceOnSurfaceOfBlock(tilePos.down(new TilePos())) && super.canPlaceAt(world, tilePos);
+        return this.isSupported(world, tilePos, Side.BOTTOM);
     }
 
     @Override
@@ -238,4 +240,8 @@ public class BlockLogicRepeater extends BlockLogic {
         world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, 0, 0, 0, redstoneBrightness);
     }
 
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return FullSupport.INSTANCE;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
index 57a96ee9c..6fd2d552f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
@@ -206,8 +206,8 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public int getLightmapCoord(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
-        return source.getLightmapCoord(tilePos, this.block.emission > 0 ? 15 : 0);
+    public byte getLightIndex(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        return source.getLightIndex(tilePos, this.block.emission > 0 ? 15 : 0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 0c5cb84ea..09103a1ed 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -1,47 +1,45 @@
 package net.minecraft.core.entity;
 
-import java.util.List;
-import java.util.Random;
-
-import net.minecraft.core.block.BlockLogicFluid;
-import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Materials;
-import net.minecraft.core.entity.animal.MobPig;
-import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.block.piston.BlockLogicPistonHead;
-import net.minecraft.core.util.collection.NamespaceID;
-import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.helper.DyeColor;
-import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.ICarriable;
-import net.minecraft.core.world.pos.TilePos;
-import net.minecraft.core.world.pos.TilePosc;
-import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
-
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.DoubleTag;
 import com.mojang.nbt.tags.FloatTag;
 import com.mojang.nbt.tags.ListTag;
-
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicFluid;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
-import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.data.SynchedEntityData;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.Vector3dc;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
+import java.util.List;
+import java.util.Random;
+
 public abstract class Entity
     implements IVehicle {
     public static final int DATA_SHARED_FLAGS_ID = 0;
@@ -795,63 +793,28 @@ public abstract class Entity
         return calcBrightness(partialTick);
     }
 
-    public int calcLightmap(float partialTick) {
-        if (Global.accessor.isFullbrightEnabled()) return 15 << 20 | 15;
+    public byte calcLightIndex(float partialTick) {
+        if (Global.accessor.isFullbrightEnabled()) return LightIndexHelper.lightIndex2i(15, 15);
         TilePos blockPos = new TilePos(this.x, this.y - this.heightOffset + this.ySlideOffset + this.bbHeight * 0.66D, this.z);
 
-        final int skylight;
-        final int blocklight;
+        byte lightIndex = 0;
         if (this.world.getBlockLitInteriorSurface(blockPos)) {
             TilePos queryPos = new TilePos();
 
-            int bU = this.world.getSavedLightValue(LightLayer.Block, blockPos.up(queryPos));
-            final int bW = this.world.getSavedLightValue(LightLayer.Block, blockPos.west(queryPos));
-            final int bE = this.world.getSavedLightValue(LightLayer.Block, blockPos.east(queryPos));
-            final int bS = this.world.getSavedLightValue(LightLayer.Block, blockPos.south(queryPos));
-            final int bN = this.world.getSavedLightValue(LightLayer.Block, blockPos.north(queryPos));
-            if (bW > bU) {
-                bU = bW;
-            }
-            if (bE > bU) {
-                bU = bE;
-            }
-            if (bS > bU) {
-                bU = bS;
-            }
-            if (bN > bU) {
-                bU = bN;
-            }
-            blocklight = bU;
-
-            int sU = this.world.getSavedLightValue(LightLayer.Sky, blockPos.up(queryPos));
-            final int sW = this.world.getSavedLightValue(LightLayer.Sky, blockPos.west(queryPos));
-            final int sE = this.world.getSavedLightValue(LightLayer.Sky, blockPos.east(queryPos));
-            final int sS = this.world.getSavedLightValue(LightLayer.Sky, blockPos.south(queryPos));
-            final int sN = this.world.getSavedLightValue(LightLayer.Sky, blockPos.north(queryPos));
-            if (sW > sU) {
-                sU = sW;
-            }
-            if (sE > sU) {
-                sU = sE;
-            }
-            if (sS > sU) {
-                sU = sS;
-            }
-            if (sN > sU) {
-                sU = sN;
-            }
-            skylight = sU;
-
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.up(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.west(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.east(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.south(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.north(queryPos)));
         } else {
-            skylight = this.world.getSavedLightValue(LightLayer.Sky, blockPos);
-            blocklight = this.world.getSavedLightValue(LightLayer.Block, blockPos);
+            lightIndex = this.world.getSavedLightIndex(blockPos);
         }
 
-        return this.world.getLightmapCoord(skylight, blocklight);
+        return lightIndex;
     }
 
-    public int getLightmap(float partialTick) {
-        return calcLightmap(partialTick);
+    public byte getLightIndex(float partialTick) {
+        return calcLightIndex(partialTick);
     }
 
     public void setWorld(@NotNull final World world) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
index 583a3aa94..9ec9c62f4 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.entity;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSand;
@@ -9,11 +10,10 @@ import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
@@ -196,59 +196,24 @@ public class EntityFallingBlock extends Entity
     }
 
     @Override
-    public int calcLightmap(float partialTick) {
-        if (Global.accessor.isFullbrightEnabled()) return 15 << 20 | 15;
+    public byte calcLightIndex(float partialTick) {
+        if (Global.accessor.isFullbrightEnabled()) return LightIndexHelper.lightIndex2i(15, 15);
         TilePos blockPos = new TilePos(this.x, this.y - this.heightOffset + this.ySlideOffset + this.bbHeight * 0.66D, this.z);
 
-        final int skylight;
-        final int blocklight;
+        byte lightIndex = 0;
         if (this.world.getBlockLitInteriorSurface(blockPos) || this.world.getBlockType(blockPos) == this.carriedBlock.block()) {
             TilePos queryPos = new TilePos();
 
-            int bU = this.world.getSavedLightValue(LightLayer.Block, blockPos.up(queryPos));
-            final int bW = this.world.getSavedLightValue(LightLayer.Block, blockPos.west(queryPos));
-            final int bE = this.world.getSavedLightValue(LightLayer.Block, blockPos.east(queryPos));
-            final int bS = this.world.getSavedLightValue(LightLayer.Block, blockPos.south(queryPos));
-            final int bN = this.world.getSavedLightValue(LightLayer.Block, blockPos.north(queryPos));
-            if (bW > bU) {
-                bU = bW;
-            }
-            if (bE > bU) {
-                bU = bE;
-            }
-            if (bS > bU) {
-                bU = bS;
-            }
-            if (bN > bU) {
-                bU = bN;
-            }
-            blocklight = bU;
-
-            int sU = this.world.getSavedLightValue(LightLayer.Sky, blockPos.up(queryPos));
-            final int sW = this.world.getSavedLightValue(LightLayer.Sky, blockPos.west(queryPos));
-            final int sE = this.world.getSavedLightValue(LightLayer.Sky, blockPos.east(queryPos));
-            final int sS = this.world.getSavedLightValue(LightLayer.Sky, blockPos.south(queryPos));
-            final int sN = this.world.getSavedLightValue(LightLayer.Sky, blockPos.north(queryPos));
-            if (sW > sU) {
-                sU = sW;
-            }
-            if (sE > sU) {
-                sU = sE;
-            }
-            if (sS > sU) {
-                sU = sS;
-            }
-            if (sN > sU) {
-                sU = sN;
-            }
-            skylight = sU;
-
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.up(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.west(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.east(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.south(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.north(queryPos)));
         } else {
-            skylight = this.world.getSavedLightValue(LightLayer.Sky, blockPos);
-            blocklight = this.world.getSavedLightValue(LightLayer.Block, blockPos);
+            lightIndex = this.world.getSavedLightIndex(blockPos);
         }
 
-        return this.world.getLightmapCoord(skylight, blocklight);
+        return lightIndex;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index e58ae8690..4488db962 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -7,6 +7,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
@@ -253,7 +254,7 @@ public class MobGhast extends MobFlying
     }
 
     @Override
-    public int calcLightmap(float partialTick) {
-        return this.world.getLightmapCoord(15, 15);
+    public byte calcLightIndex(float partialTick) {
+        return LightIndexHelper.lightIndex2i(15, 15);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/enums/LightLayer.java b/game/core/src/main/java/net/minecraft/core/enums/LightLayer.java
index a65a1c1ef..e5c8cb9ec 100644
--- a/game/core/src/main/java/net/minecraft/core/enums/LightLayer.java
+++ b/game/core/src/main/java/net/minecraft/core/enums/LightLayer.java
@@ -1,9 +1,12 @@
 package net.minecraft.core.enums;
 
+import net.minecraft.core.util.helper.LightIndexHelper;
+
 public enum LightLayer
 {
     Sky(15),
     Block(0);
+    public static final byte DEFAULT_LIGHT_INDEX = LightIndexHelper.lightIndex2i(Sky.defaultLightLevel, Block.defaultLightLevel);
 
     LightLayer(int defaultLightLevel)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/LightIndexHelper.java b/game/core/src/main/java/net/minecraft/core/util/helper/LightIndexHelper.java
new file mode 100644
index 000000000..62e4478ea
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/LightIndexHelper.java
@@ -0,0 +1,58 @@
+package net.minecraft.core.util.helper;
+
+public final class LightIndexHelper {
+    private LightIndexHelper() {
+
+    }
+
+    public static byte lightIndex2i(int skyLight, int blockLight) {
+        return (byte) ((skyLight & 0xF) << 4  | blockLight & 0xF);
+    }
+
+    public static byte lightIndex2f(float skyLight, float blockLight) {
+        return lightIndex2i((int) (skyLight * 0xF), (int) (blockLight * 0xF));
+    }
+
+    public static int skyLightFromIndex(byte lightIndex) {
+        return (lightIndex >> 4) & 0xF;
+    }
+
+    public static int blockLightFromIndex(byte lightIndex) {
+        return lightIndex & 0xF;
+    }
+
+    public static byte setSkyLight(byte lightIndex, int skyLight) {
+        return (byte) ((skyLight & 0xF) << 4 | (lightIndex & 0xF));
+    }
+
+    public static byte setBlockLight(byte lightIndex, int blockLight) {
+        return (byte) ((lightIndex & 0xF0) | (blockLight & 0xF));
+    }
+
+    public static byte max(byte lightIndex1, byte lightIndex2) {
+        int sky1 = (lightIndex1 >> 4) & 0xF;
+        int sky2 = (lightIndex2 >> 4) & 0xF;
+
+        int block1 = lightIndex1 & 0xF;
+        int block2 = lightIndex2 & 0xF;
+
+        return (byte) (Math.max(sky1, sky2) << 4 | Math.max(block1, block2));
+    }
+
+    public static byte avg(byte lightIndex1, byte lightIndex2) {
+        int sky0 = (lightIndex1 >> 4) & 0xF;
+        int sky1 = (lightIndex2 >> 4) & 0xF;
+
+        int block0 = lightIndex1 & 0xF;
+        int block1 = lightIndex2 & 0xF;
+
+        int sky = (sky0 + sky1) >> 1;
+        int block = (block0 + block1) >> 1;
+
+        return (byte) (sky << 4 | block);
+    }
+
+    public static byte avg(byte lightIndex1, byte lightIndex2, byte lightIndex3, byte lightIndex4) {
+        return avg(avg(lightIndex1, lightIndex2), avg(lightIndex3, lightIndex4));
+    }
+}
